/***************************************************************************
 *                                                                         *
 *   KNetLoad is copyright (c) 1999-2000, Markus Gustavsson                *
 *                         (c) 2002, Ben Burton                            *
 *                         (c) 2004, Diego Petten                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __KNETLOAD_H
#define __KNETLOAD_H

#include "statpopup.h"

#include <qptrlist.h>

class KAction;
class KNetProc;
class KPopupMenu;

/**
 * The specific pop-up window used by KNetLoad.
 */
class KNetLoad : public StatPopup {
    Q_OBJECT

public:
    /**
     * Constructor and destructor.
     */
    KNetLoad(QWidget *parent = 0, const char *name = 0);
    ~KNetLoad();

public slots:
    virtual void reloadSettings();

protected:
    /**
     * Overrides from StatPopup.
     */
    virtual QString dockName(int which) const;
    virtual void takeReadingInternal();

private:
    /**
     * Reading raw network throughput information.
     */
    KNetProc* proc;
        /**< Used to obtain the raw information. */
    float bitRateIn, bitRateOut;
        /**< Temporary variables used in calculations. */

    /**
     * Lists of menus that must be kept up-to-date.
     */
    QPtrList<KPopupMenu> scaleInMenus;
    QPtrList<KPopupMenu> scaleOutMenus;
    
    QStringList stockDevice;
    QStringList stockDeviceIcon;
};

#endif
